#include <stdio.h>
#include <stdlib.h>

struct drvo
{
int broj;
char poz;
struct drvo *levi,*desni;
};


#define novi(x) x=(struct drvo *) malloc(sizeof(struct drvo))
void ucitaj(FILE *f,int *vraca,char *poz)
{
int broj,cifra,broj2,broj3;

	fscanf(f,"%d",&broj);
	fscanf(f,"%d",&cifra);
	
	broj2=(broj*10)+cifra; //na kraj
	broj3=(cifra*1000)+broj; //na pocetak
	
	if (broj2>broj3) 
	{*vraca=broj2;
	*poz='K';
	}
	else 
	{
	*vraca=broj3;
	*poz='P';
	}	
}

void dodaj(struct drvo **p,int broj,char poz)
{
struct drvo *el,*pom1,*pom2;
novi(el);
		if(!el)
		{
		printf("Greska pri alokaciji memorije.\n");
		exit(0);
		}
el->broj=broj;
el->poz=poz;
el->levi=el->desni=NULL;

	if(!(*p)) *p=el;
	else
	{
	pom1=*p;
	while(pom1) {
				pom2=pom1;
				if(broj<pom1->broj)	pom1=pom1->levi;
				else pom1=pom1->desni;
				}
	if(broj<pom2->broj) pom2->levi=el;
		else pom2->desni=el;
	}
}

struct drvo *formiraj(FILE *f,int *x)
{
	int b,i;
	int vraca;
	char poz;
	fscanf(f,"%d",&b);
	struct drvo *koren=NULL;
	for(i=0;i<b;i++)
	{ucitaj(f,&vraca,&poz);
	dodaj(&koren,vraca,poz);
	}
	fscanf(f,"%d",x);
return koren;
}

void ispis(struct drvo *p)
{
	if(p){
			ispis(p->desni);
			printf("%d %c\t",p->broj,p->poz);
			ispis(p->levi);
		 }
		
}

void prebroj(struct drvo *p,int *br,int x)
{
	
	if(p){if((p->broj>x)&&(p->poz=='P')) ++(*br);
		prebroj(p->levi,br,x);
		prebroj(p->desni,br,x);}
}
int main(int argc,char*argv[])
{
FILE *f=fopen(argv[1],"r");
struct drvo *p=NULL;
int x,br=0;
p=formiraj(f,&x);
printf("Ispis:\n");
ispis(p);
printf("\n");
printf("X je: %d\n",x);
prebroj(p,&br,x);
printf("Formiranih brojeva vecih od unetog broja X, gde je cifra dodata na pocetak ima: %d\n",br);
return 0;
}


