#include<stdio.h>
#include<stdlib.h>

struct polje{
	char boja;
	struct polje *levo, *desno;
	};

#define obezbedi(x) x=(struct polje *) malloc(sizeof(struct polje))

void dodaj(struct polje **pocetak, struct polje **kraj, char c){
	struct polje *p, *k, *temp;
	p=*pocetak;	k=*kraj;
	
	obezbedi(temp);
	if(!temp){
		printf("Greska pri alokaciji memorije!\n");
		exit(0);
		}
	
	temp->boja=c;
	
	if(!p) {
		p=temp;
		k=temp;
		temp->levo=temp->desno=NULL;
		}
	else {
		temp->desno=NULL;
		temp->levo=k;
		k->desno=temp;
		k=temp;
		}
	
	*pocetak=p;
	*kraj=k;
	}
	

void formiraj(struct polje **pocetak, struct polje **kraj, FILE *f){
	char c;
	c=fgetc(f);
	
	while(!feof && c!='0'){
		dodaj(pocetak, kraj, c);
		fgetc(f);
		c=fgetc(f);
		}
	printf("Poligon formiran!\n");
	}

void ispis(struct polje *pocetak){
	char c;
	printf("Pisem!");
	while(pocetak){
		c=pocetak->boja;
		//putchar(c);
		printf("%c",c);
		pocetak=pocetak->desno;
		}
	return;
	}

main(int argc, char *argv[]){
	FILE *f;
	f=fopen(argv[1],"r");
	if(!f){
		printf("Greska pri otvaranju datoteke!\n");
		exit(0);
		}
	
	struct polje *pocetak, *kraj;
	pocetak=NULL;	kraj=NULL;
	
	formiraj(&pocetak, &kraj, f);
	printf("Poligon pre:\n");
	ispis(pocetak);
	
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	











