#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct drvo {
	int broj;
	char poz;
	struct drvo *levi, *desni;
};

#define novi(x) x = (struct drvo *)malloc(sizeof(struct drvo))

int Spoji(int br, int c, char *poz) {
	int c1, c2, c3;
	int x;
	c3 = br % 10;
	c2 = (br / 10) % 10;
	c1 = (br / 10) / 10;
	if (c <= c1) {
		x = c1*1000+c2*100+c3*10+c;
		*poz = 'K';
		return x;
	}
	else {
		x = c*1000+c1*100+c2*10+c3;
		*poz = 'P';
		return x;
	}
}

void Dodaj(struct drvo **p, int n, int c) {
	struct drvo *temp, *pom1, *pom2;
	novi(temp);
	if (!temp) {
		printf("Greska pri alokaciji memorije.\n");
		exit(0);
	}
	temp->broj = Spoji(n, c, &temp->poz);
	temp->levi = NULL;
	temp->desni = NULL;
	if (!(*p)) *p = temp;
	else {
		pom1 = *p;
		while (pom1) {
			pom2 = pom1;
			if (temp->broj < pom1->broj) pom1 = pom1->levi;
			else pom1 = pom1->desni;
		}
		if (temp->broj < pom2->broj) pom2->levi = temp;
		else pom2->desni = temp;
	}
}

void Ispis(struct drvo *p) {
	if (p) {
		Ispis(p->desni);
		printf("%6d %c", p->broj, p->poz);
		Ispis(p->levi);
	}
}

int Trazi(struct drvo *p, int tr) {
	if (p) {
		if ((p->broj > tr) && (p->poz == 'P')) return (1 + Trazi(p->levi, tr) + Trazi(p->desni, tr));
		else return (0 + Trazi(p->levi, tr) + Trazi(p->desni, tr));
	}
}	
	
main () {
	struct drvo *p = NULL;
	int b, n, c, i, tr;
	scanf("%d", &b);
	for (i=0; i<b; i++) {
		scanf("%d", &n);
		scanf("%d", &c);
		Dodaj(&p, n, c);
	}
	Ispis(p);
	scanf("%d",&tr);
	printf("Veci od X: %d\n", Trazi(p, tr));
}
	
